PUI = LibStub("AceAddon-3.0"):NewAddon("PowerUI", "AceConsole-3.0", "AceEvent-3.0")

local defaults = {
	profile = {
		UnitFrames = {
			player = {
				x = 5,
				y = -10,
				ref = "TOPLEFT",
				scale = 1
			},
			target = {
				x = 275,
				y = -10,
				ref = "TOPLEFT",
				scale = 1
			},
			focus = {
				x = 275,
				y = -300,
				ref = "TOPLEFT",
				scale = 1
			},
			arena = {
				x = -250,
				y = 50,
				ref = "RIGHT",
				scale = 1.3
			},
			party = {
				x = 5,
				y = 50,
				ref = "LEFT",
				scale = 1.3
			},
			classIcons = true,
			classColors = true
		},
		ActionBars = {
			modify = true,
			macroText = true,
			CastBar = {
				x = 0,
				y = 250,
			},
			rangeIndicator = true
		},
		chat = true
	}
}

		-- GETS N' SETS N' STUFF
		
function PUI:GetColors()
	return self.db.profile.UnitFrames.classColors
end


		-- And now we may begin.
function PUI:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("PUIDB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	
	local options = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("PowerUI", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PowerUI", "PowerUI")
	self:RegisterChatCommand("PUI", "ChatCommand")
	self:RegisterChatCommand("PowerUI", "ChatCommand")
	
	PUI:Print("loaded.")
end

function PUI:RefreshConfig()
	ReloadUI()
end

function PUI:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	--self:RegisterEvent("ADDON_LOADED", name)
	--self:RegisterEvent("UPDATE_EXTRA_ACTIONBAR")
end

function PUI:OnDisable()
	ReloadUI()
end

--[[function PUI:ADDON_LOADED(name)
	if name == "Blizzard_ArenaUI" then
		PUI:PositionArenaFrames()
	end
end]]

function PUI:PositionArenaFrames()
	local DB = self.db.profile.UnitFrames.arena
	ArenaEnemyFrames:Show()
	for i=1,5 do _G["ArenaPrepFrame"..i]:ClearAllPoints() end
	for i=1,5 do _G["ArenaEnemyFrame"..i]:ClearAllPoints() end
	ArenaPrepFrames:ClearAllPoints()
	ArenaEnemyFrames:ClearAllPoints()
			
	ArenaPrepFrame1:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y)
	ArenaPrepFrame2:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-50)
	ArenaPrepFrame3:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-100)
	ArenaPrepFrame4:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-150)
	ArenaPrepFrame5:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-200)
	ArenaEnemyFrame1:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y)
	ArenaEnemyFrame2:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-50)
	ArenaEnemyFrame3:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-100)
	ArenaEnemyFrame4:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-150)
	ArenaEnemyFrame5:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-200)
	
	ArenaEnemyFrame1.SetPoint = function() end
	ArenaEnemyFrame2.SetPoint = function() end
	ArenaEnemyFrame3.SetPoint = function() end
	ArenaEnemyFrame4.SetPoint = function() end
	ArenaEnemyFrame5.SetPoint = function() end
	ArenaPrepFrame1.SetPoint = function() end
	ArenaPrepFrame2.SetPoint = function() end
	ArenaPrepFrame4.SetPoint = function() end
	ArenaPrepFrame4.SetPoint = function() end
	ArenaPrepFrame5.SetPoint = function() end
	
	ArenaEnemyFrames:SetScale(DB.scale)
	for i=1,5 do _G["ArenaPrepFrame"..i]:SetScale(DB.scale) end
end

function PUI:PLAYER_ENTERING_WORLD()
	hooksecurefunc("PlayerFrame_SetLocked", function()
		local point, relativeTo, relativePoint, xOffset, yOffset = PlayerFrame:GetPoint()
		local DB = self.db.profile.UnitFrames.player
		DB.x = xOffset
		DB.y = yOffset
		DB.ref = point
	end)
	hooksecurefunc("TargetFrame_SetLocked", function()
		local point, relativeTo, relativePoint, xOffset, yOffset = TargetFrame:GetPoint()
		local DB = self.db.profile.UnitFrames.target
		DB.x = xOffset
		DB.y = yOffset
		DB.ref = point
	end)
	hooksecurefunc("FocusFrame_SetLock", function()
		local point, relativeTo, relativePoint, xOffset, yOffset = FocusFrame:GetPoint()
		local DB = self.db.profile.UnitFrames.focus
		DB.x = xOffset
		DB.y = yOffset
		DB.ref = point
	end)

	_, arenaCheck = IsInInstance()
	if arenaCheck == "arena" then
		PUI:PositionArenaFrames()
		--[[hooksecurefunc("ArenaEnemyFrame_OnEvent", function(...)
			if not UnitAffectingCombat("player") then PUI:PositionArenaFrames() end
		end)
		hooksecurefunc("ArenaEnemyFrame_SetMysteryPlayer", function(...)
			if not UnitAffectingCombat("player") then PUI:PositionArenaFrames() end
		end)
		hooksecurefunc("ArenaEnemyFrame_UpdatePlayer", function(...)
			if not UnitAffectingCombat("player") then PUI:PositionArenaFrames() end
		end)
		hooksecurefunc("ArenaEnemyFrame_UpdatePet", function(...)
			if not UnitAffectingCombat("player") then PUI:PositionArenaFrames() end
		end)
		hooksecurefunc("ArenaEnemyFrames_OnEvent", function(...)
			if not UnitAffectingCombat("player") then PUI:PositionArenaFrames() end
		end)]]
	end
	

	local DB = self.db.profile.UnitFrames
	PlayerFrame:SetMovable(true)
	PlayerFrame:SetUserPlaced(true)
	PlayerFrame:ClearAllPoints()
	PlayerFrame:SetPoint(DB.player.ref, UIParent, DB.player.ref, DB.player.x, DB.player.y)
	PlayerFrame:SetScale(DB.player.scale)
	hooksecurefunc("PlayerFrame_Update", function()
		PlayerFrame:ClearAllPoints()
		PlayerFrame:SetPoint(DB.player.ref, UIParent, DB.player.ref, DB.player.x, DB.player.y)
		PlayerFrame:SetScale(DB.player.scale)
	end)
	TargetFrame:ClearAllPoints()
	TargetFrame:SetPoint(DB.target.ref, UIParent, DB.target.ref, DB.target.x, DB.target.y)
	TargetFrame:SetScale(DB.target.scale)
	TargetFrameToT:ClearAllPoints()
	TargetFrameToT:SetPoint("BOTTOMRIGHT",TargetFrame,-15,-10)
	FocusFrame:ClearAllPoints()
	FocusFrame:SetPoint(DB.focus.ref, UIParent, DB.focus.ref, DB.focus.x, DB.focus.y)
	FocusFrame:SetScale(DB.focus.scale)
	FocusFrameToT:ClearAllPoints()
	FocusFrameToT:SetPoint("BOTTOMRIGHT",FocusFrame,-15,-10)
	
	if self.db.profile.ActionBars.modify == true then
		ActionBarUpButton:Hide()
		ActionBarDownButton:Hide()
		MainMenuBarPageNumber:Hide()
		MainMenuBarLeftEndCap:Hide()
		MainMenuBarRightEndCap:Hide()
		MainMenuBarMaxLevelBar:Hide()
		for i=0,3 do _G["MainMenuBarTexture"..i]:Hide() end
		for i=0,3 do _G["MainMenuMaxLevelBar"..i]:Hide() end
		
		MainMenuBar:RegisterEvent("PLAYER_EXITING_VEHICLE")
		MultiBarBottomLeft:RegisterEvent("PLAYER_EXITING_VEHICLE")
		MultiBarBottomRight:RegisterEvent("PLAYER_EXITING_VEHICLE")
		
		MainMenuBar:ClearAllPoints()
		MainMenuBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOM", -250, 35)
		MainMenuBarBackpackButton:ClearAllPoints()
		MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", MainMenuMicroButton, "TOPRIGHT", -3, -15)
		hooksecurefunc("MainMenuBar_OnEvent", function(self, event, ...)
			if event == "PLAYER_EXITING_VEHICLE" then
				self:ClearAllPoints()
				self:SetPoint("BOTTOMLEFT", UIParent, "BOTTOM", -250, 35)
				MainMenuBarBackpackButton:ClearAllPoints()
				MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", MainMenuMicroButton, "TOPRIGHT", -3, -15)
			end
		end)
				
		MultiBarBottomLeft:SetMovable(true)
		MultiBarBottomLeft:SetUserPlaced(true)
		MultiBarBottomLeft:ClearAllPoints()
		MultiBarBottomLeft:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 7)
		MultiBarBottomLeft:SetFrameStrata("BACKGROUND")
		local function MultiBar1Event(self, event, ...)
			if event == "PLAYER_EXITING_VEHICLE" then
				self:ClearAllPoints()
				self:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 7)
			end
		end
		MultiBarBottomLeft:SetScript("OnEvent", MultiBar1Event)
				
		MultiBarBottomRight:SetMovable(true)
		MultiBarBottomRight:SetUserPlaced(true)
		MultiBarBottomRight:ClearAllPoints()
		MultiBarBottomRight:SetPoint("BOTTOM",MultiBarBottomLeft,"TOP",0,5)
		MultiBarBottomRight:SetFrameStrata("BACKGROUND")
		local function MultiBar2Event(self, event, ...)
			if event == "PLAYER_EXITING_VEHICLE" then
				self:ClearAllPoints()
				self:SetPoint("BOTTOM",MultiBarBottomLeft,"TOP",0,5)
			end
		end
		MultiBarBottomRight:SetScript("OnEvent", MultiBar2Event)
				
					-- Pet Bars
		PetActionBarFrame:SetMovable(true)
		PetActionBarFrame:SetUserPlaced(true)
		PetActionBarFrame:ClearAllPoints()
		PetActionBarFrame:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton2, "TOPLEFT", -15, 7)
		PetActionBarFrame:SetFrameStrata("BACKGROUND")
		PetActionBarFrame.SetPoint = function() end
				
					-- Stance Bars
		StanceBarFrame:SetMovable(true)
		StanceBarFrame:SetUserPlaced(true)
		StanceBarFrame:ClearAllPoints()
		StanceBarFrame:SetPoint("BOTTOM", PetActionButton1, "TOP", 0, 7)
		StanceBarFrame:SetFrameStrata("BACKGROUND")
				
					-- Exp and Rep bars
		MainMenuExpBar:ClearAllPoints()
		MainMenuExpBar:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 0)
		ReputationWatchBar:ClearAllPoints()
		ReputationWatchBar:SetPoint("BOTTOM", MainMenuExpBar, "TOP", 0, 3)
		hooksecurefunc("ReputationWatchBar_Update", function(newLevel)
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("BOTTOM", MainMenuExpBar, "TOP", 0, 3)
		end)
		
		-- Out of Range full-icon coloration
		if self.db.profile.ActionBars.rangeIndicator == true then
		hooksecurefunc("ActionButton_OnEvent",function(self, event, ...)
			if ( event == "PLAYER_TARGET_CHANGED" ) then
				self.newTimer = self.rangeTimer
			end
		end)

		hooksecurefunc("ActionButton_UpdateUsable",function(self)
			local icon = self.icon
			local valid = IsActionInRange(self.action)
			if ( valid == false ) then
				icon:SetVertexColor(1.0, 0.1, 0.1)
			end
		end)

		hooksecurefunc("ActionButton_OnUpdate",function(self, elapsed)
			local rangeTimer = self.newTimer
			if ( rangeTimer ) then
				rangeTimer = rangeTimer - elapsed
				if ( rangeTimer <= 0 ) then
					ActionButton_UpdateUsable(self)
					rangeTimer = TOOLTIP_UPDATE_TIME
				end
				self.newTimer = rangeTimer
			end
		end)
		end
	
		ExtraActionButton1:ClearAllPoints()
		ExtraActionButton1:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 5)
		-- Look below for EAB1 update event.
		
		CastingBarFrame:SetMovable(true)
		CastingBarFrame:SetUserPlaced(true)
		hooksecurefunc("CastingBarFrame_OnUpdate",function()
			if (CastingBarFrame.casting) then
				CastingBarFrame:ClearAllPoints()
				CastingBarFrame:SetPoint("BOTTOM", UIParent, "BOTTOM", self.db.profile.ActionBars.CastBar.x, self.db.profile.ActionBars.CastBar.y)
			end
		end)
		
		if self.db.profile.ActionBars.macroText == false then
			for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(0) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(0) end
		end
	end
	
	if self.db.profile.UnitFrames.classIcons == true then
		hooksecurefunc("UnitFramePortrait_Update", function(self)
			if self.portrait and UnitIsPlayer(self.unit) and self.unit ~= "player" and self.unit ~= "pet" and self.unit ~= nil then
				local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))]
				if t then
					self.portrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
					self.portrait:SetTexCoord(unpack(t))
				end
			else
				if self.portrait ~= nil then
					SetPortraitTexture(self.portrait, self.unit)
					self.portrait:SetTexCoord(0,1,0,1)
				end
			end
		end)
		
	end
	
	if self.db.profile.chat == true then
		for i=1,NUM_CHAT_WINDOWS do _G["ChatFrame"..i]:SetFont("Fonts\\ARIALN.TTF",15,"OUTLINE")end
		hooksecurefunc("FloatingChatFrame_Update",function(id, ...)
			_G["ChatFrame"..id]:SetFont("Fonts\\ARIALN.TTF",15,"OUTLINE")
		end)
	end
	
	Minimap:EnableMouseWheel(true)
	Minimap:SetScript('OnMouseWheel', function(self, delta)
		if delta > 0 then
			Minimap_ZoomIn()
		else
			Minimap_ZoomOut()
		end
	end)
	
	local DB = PUI.db.profile.UnitFrames.party
	for i=1,4 do _G["PartyMemberFrame"..i]:ClearAllPoints() end
	PartyMemberFrame1:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y)
	PartyMemberFrame2:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-70)
	PartyMemberFrame3:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-140)
	PartyMemberFrame4:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-210)
	for i=1,4 do _G["PartyMemberFrame"..i]:SetScale(DB.scale) end
	for i=1,4 do _G["PartyMemberFrame"..i.."PetFrame"]:SetAlpha(0) end
	hooksecurefunc("PartyMemberFrame_UpdatePet", function(...)
		for i=1,4 do _G["PartyMemberFrame"..i.."PetFrame"]:SetAlpha(0) end
	end)
end

--[[function PUI:UPDATE_EXTRA_ACTIONBAR()
	if self.db.profile.ActionBars.modify then
		ExtraActionButton1:ClearAllPoints()
		ExtraActionButton1:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 5)
	end
end]]

function PUI:ChatCommand(input)
	curProfile = self.db:GetCurrentProfile()
	PUI:OpenConfig(curProfile)
end